// DavCommand.h: interface for the CDavCmdDispatcher class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DAVCOMMAND_H__B5BD65A6_FB1B_11D3_BB07_00609733C58A__INCLUDED_)
#define AFX_DAVCOMMAND_H__B5BD65A6_FB1B_11D3_BB07_00609733C58A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
 *	Martin Hallerdal, marty@home.se
 *	2000-05-11
 *
 *	Please feel free to experiment with the code. Just don't use it for commercial purposes.
 */


#include "Headers.h"
#include "HttpConst.h"
#include "DavCmd.h"

typedef enum { NOT_INIT, NOT_DAV, PROPFIND, COPY, MOVE, MKCOL, DEL } DavCmd;

class CDavCmdDispatcher  
{
	friend class CDavCmd;
	friend class CPropFindCmd;
	friend class CMkColCmd;
	friend class CDeleteCmd;
	friend class CCopyCmd;
	friend class CMoveCmd;

public:
	bool Execute(CHttpFilterContext*);
	void SetCommandBody(char* pcData, DWORD dwLength);

	bool IsDavCommand();		
	
	void SetPhysicalLocation(const char* szPhys, int iLen);
	void SetURI(char* szURI);
	void SetMethod(char *szMethod);
	void SetHeaders(CHeaders* pHdrs);

	CDavCmdDispatcher();
	virtual ~CDavCmdDispatcher();

protected:
	bool SetSecurity();
	CDavCmd* GetCommandInstance();
	CHttpFilterContext* pCtx;

	HANDLE hUser;			//Handle of a user if we impersonate
	bool bLoggedOn;			//Did we impersonate?

	DavCmd cmd;
	char szPhys[MAX_PATH];		//The physical location of the resource
	char szURI[512];		//URI of the resource
	char* szMethod;		//What method is used
	char* szBody;		//The command body
	DWORD dwBodyLen;	//The body length
	CHeaders* pHdrs;	//The headers
};

#endif // !defined(AFX_DAVCOMMAND_H__B5BD65A6_FB1B_11D3_BB07_00609733C58A__INCLUDED_)
