// MkColCmd.cpp: implementation of the MkColCmd class.
//
//////////////////////////////////////////////////////////////////////

/*
 *	Martin Hallerdal, marty@home.se
 *	2000-05-11
 *
 *	Please feel free to experiment with the code. Just don't use it for commercial purposes.
 */


#include "stdafx.h"
#include "DavFilter.h"
#include "MkColCmd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMkColCmd::CMkColCmd(CDavCmdDispatcher* disp, CHttpFilterContext* pCtx) :  CDavCmd(disp, pCtx)
{

}

CMkColCmd::~CMkColCmd()
{

}


/*
	Executes a MKCOL command
*/

bool CMkColCmd::Execute() {

	
	
	BOOL bRetVal;
	
	resp.SetStatus(201);

	if(pDisp->dwBodyLen != 0) {
		resp.SetStatus(415);
		
	} else {
		
		//Make sure ancestor directory exist
		
		if(!AncestorExist()) {
			resp.SetStatus(409);

		} else {
			
			//Try to create it
			
			bRetVal = ::CreateDirectory(pDisp->szPhys, NULL);
			
			if(bRetVal == FALSE) {
				DWORD dwErr = GetLastError();
				
				switch(dwErr) {
					
				case ERROR_ACCESS_DENIED:
					resp.SetStatus(403);
					break;
					
				case ERROR_DISK_FULL:
					resp.SetStatus(507);
					break;

				case ERROR_ALREADY_EXISTS:
					resp.SetStatus(405);
					break;

				case ERROR_FILE_EXISTS:
					resp.SetStatus(405);
					break;
	
				case ERROR_CANNOT_MAKE:
					resp.SetStatus(403);
					break;

				default: 
					resp.SetStatus(403);
					break;
				}
			} 
			
		}
	}

	//Send response to client

	resp.SendResponse(pCtx);

	return true;
}

