#ifndef __DAV_PROPS
#define __DAV_PROPS

/*
 *	Martin Hallerdal, marty@home.se
 *	2000-05-11
 *
 *	Please feel free to experiment with the code. Just don't use it for commercial purposes.
 */


#include <vector>


//Defines a link between an XML name and a value

typedef struct { 
	char* szName; 
	DWORD dwVal;
} DavProperty;


//Defined DAV properties

#define DAV_CREATIONDATE_PROP 1
#define DAV_DISPLAYNAME_PROP 2
#define DAV_GETCONTENTLANGUAGE_PROP 4
#define DAV_GETCONTENTLENGTH_PROP 8
#define DAV_GETCONTENTTYPE_PROP 16
#define DAV_GETETAG_PROP 32
#define DAV_GETLASTMODIFIED_PROP 64
#define DAV_LOCKDISCOVERY_PROP 128
#define DAV_RESOURCETYPE_PROP 256
#define DAV_SOURCE_PROP 512
#define DAV_SUPPORTEDLOCK_PROP 1024



/*
	PropSpec is a structure that holds information about the properties
	that the client wants
*/

typedef enum { ZERO, ONE, INFINITY } PropDepth;

struct PropSpec {
	bool bJustNames;
	bool bAllProps;
	PropDepth depth;
	
	std::vector<DavProperty> dProps;		//Dav properties for this request
	std::vector<char*> props;				//Custom properties	for this request

	static const DavProperty davProps[];	//All the DAV properties we know of
	static const DWORD dwNumProps;

	void AddProperty(char *szName);

	PropSpec() : bJustNames(false), bAllProps(true), depth(INFINITY) {}
	~PropSpec();
};


#endif