// RequestInfo.h: interface for the CRequestInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REQUESTINFO_H__BA619985_F810_11D3_8364_30C359C10000__INCLUDED_)
#define AFX_REQUESTINFO_H__BA619985_F810_11D3_8364_30C359C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "DavCmdDispatcher.h"

/*
 *	Martin Hallerdal, marty@home.se
 *	2000-05-11
 *
 *	Please feel free to experiment with the code. Just don't use it for commercial purposes.
 */

class CRequestInfo  
{
public:

	DWORD GetBufferSize();
	DWORD ReceivedHeaders(char *szMethod, char* szURI);
	
	void AddData(PHTTP_FILTER_RAW_DATA theData);
	void ProcessCommand(CHttpFilterContext* pCtx);	//Treats the data in pcInput as a DAV command and executes it
	void SetPhysicalLocation(const char* plc, int len);
	void Restore();
	void SetLastBlock(char* strData, int len);
	void StackLastBlock();
	
	bool IsDavCommand();

	CRequestInfo();
	virtual ~CRequestInfo();

public:

	/* Stand-in functions for the filter */

	DWORD OnReadRawData(CHttpFilterContext* pCtxt, PHTTP_FILTER_RAW_DATA pRawData);
	DWORD OnSendRawData(CHttpFilterContext* pCtxt, PHTTP_FILTER_RAW_DATA pRawData);
	DWORD OnUrlMap(CHttpFilterContext* pCtxt, PHTTP_FILTER_URL_MAP pMapInfo);
	DWORD OnPreprocHeaders(CHttpFilterContext* pCtxt, PHTTP_FILTER_PREPROC_HEADERS pHeaderInfo);
	
	
	long lBytesToGo;

	bool bShouldIgnoreRequest;
	bool bForceReadMode;
	bool bOptionsRequest;

protected:
	
	CDavCmdDispatcher davCmd;


	DWORD dwInputLen;		//Length of input
	DWORD dwLastLen;		//Length of last block
	char* pcInput;			//All the data we have got
	char* pcLastBlock;		//The last block we received
	char* szPhysLocation;	//The physical location of the resource
	
};

#endif // !defined(AFX_REQUESTINFO_H__BA619985_F810_11D3_8364_30C359C10000__INCLUDED_)
