// Response.cpp: implementation of the CResponse class.
//
//////////////////////////////////////////////////////////////////////

/*
 *	Martin Hallerdal, marty@home.se
 *	2000-05-11
 *
 *	Please feel free to experiment with the code. Just don't use it for commercial purposes.
 */


#include "stdafx.h"
#include "HttpConst.h"
#include "Response.h"
#include "HttpUtil.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CResponse::CResponse() : pBody(NULL)
{

}

CResponse::~CResponse()
{
	SAFE_FREE_PTR(pBody)

}


void CResponse::SendResponse(CHttpFilterContext* pCtx) {

	DWORD dwLineLen;

	//Required headers


	//Set server date
	time_t nu;
	::time(&nu);

	tm* t = ::gmtime(&nu);
	char* szDat = ::asctime(t);
	szDat[24] = '\0'; //That character is a \n

	hdrs.SetHeader("Date", -1, szDat, -1);
	
	//Add connection close header

	hdrs.SetHeader("Connection", -1, "close", -1);

	if(pBody) {

		//Add Content-Length and Content-Type header

		char szHeader[256]; 

	
		sprintf(szHeader, "%s", pBody->GetMimeType());
		hdrs.SetHeader("Content-Type", -1, szHeader, -1);
		
		sprintf(szHeader, "%d", pBody->GetLength());
		hdrs.SetHeader("Content-Length", -1, szHeader, -1);
	
	}

	//If we are sending access denied, give them a chance to authenticate

	if(/* pCtx->m_pFC->fIsSecurePort && */ iStatus == 401) {
		char szAuth[128] = "Basic realm=\"";
		
		DWORD len = 128-13-1;
		pCtx->GetServerVariable("SERVER_NAME", szAuth+13, &len);
		strcat(szAuth, "\"");

		hdrs.SetHeader("WWW-Authenticate", -1, szAuth, -1);
	}



	//Write status line

	char* szStatus = ::GetStatusLineFromCode(iStatus);
	dwLineLen = strlen(szStatus);
	pCtx->WriteClient(szStatus, &dwLineLen);

	//Write headers

	char szHeaderLine[512];
	HEADERS::iterator it;

	for(it = hdrs.hdrs.begin(); it != hdrs.hdrs.end(); it++) {
		strcpy(szHeaderLine, (*it).first);
		strcat(szHeaderLine, ": ");
		strcat(szHeaderLine, (*it).second);
		strcat(szHeaderLine, pcNEWLINE);
	
		dwLineLen = strlen(szHeaderLine);
		
		pCtx->WriteClient(szHeaderLine, &dwLineLen);
	}

	//Write a newline
	
	dwLineLen = iNEWLINELENGTH;
	pCtx->WriteClient(pcNEWLINE, &dwLineLen);

	
	//Write 'em if you got 'em

	if(pBody) {
		pBody->WriteToClient(pCtx);
	}
}

void CResponse::Clear() {

	//Clear headers

	hdrs.Clear();

	//Clear body
	
	if(pBody) {
		pBody->Clear();
	}
}


/*
	Sets the status code
*/

void CResponse::SetStatus(int iStatus) {
	this->iStatus = iStatus;
}