// XMLBody.cpp: implementation of the CXMLBody class.
//
//////////////////////////////////////////////////////////////////////

/*
 *	Martin Hallerdal, marty@home.se
 *	2000-05-11
 *
 *	Please feel free to experiment with the code. Just don't use it for commercial purposes.
 */


#include "stdafx.h"
#include "DavFilter.h"
#include "XMLBody.h"
#include "HttpConst.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
char* CXMLBody::szXMLHeader = "<?xml version=\"1.0\"?>";

CXMLBody::CXMLBody() : doc(NULL) {
	dwHeaderLen = strlen(szXMLHeader);

}

CXMLBody::~CXMLBody() {
	doc = NULL;
}


void CXMLBody::Clear() {
	doc = NULL;
	dwXMLLen = 0;
}

char* CXMLBody::GetMimeType() {
	return "text/xml";
}

void CXMLBody::WriteToClient(CHttpFilterContext* pCtx) {

	/*_bstr_t bstrXML = doc->xml;
	pCtx->WriteClient(szXMLHeader, &dwHeaderLen);
	pCtx->WriteClient((char*)bstrXML, &dwXMLLen);*/


	_bstr_t bstrXML = doc->xml;
	
	DWORD dwNewLineLength = iNEWLINELENGTH;

	pCtx->WriteClient(szXMLHeader, &dwHeaderLen);
	pCtx->WriteClient(pcNEWLINE, &dwNewLineLength);
	pCtx->WriteClient((char*)bstrXML, &dwXMLLen);
}

/*
	Sets the XML document for this body
*/

void CXMLBody::SetXMLDocument(IXMLDOMDocumentPtr doc) {
 	this->doc = doc;

	_bstr_t bstrXML = doc->xml;
	char* szXML = NULL;
	szXML = (char*)bstrXML;

	dwXMLLen = strlen(szXML);
}

/*
	Returns the length of the XML body
*/

DWORD CXMLBody::GetLength() {

	//Length is XML header length + XML body length

	
	return (dwHeaderLen + dwXMLLen);
}