;
; 
; RTFEX32.ASM
; 
; Copyright (c) 1998,99 On Time
; http://www.on-time.com
; 
; Custom context save/restore functions for C Exception Handling Library 
; 
; 

; This is what we want to implement:
;
;   typedef struct {
;      unsigned long esi, edi, ebx, ret, ebp, esp;
;   } XContext;
;
;   int  __stdcall XSaveContext(XContext * C);
;   void __stdcall XRestoreContext(XContext * C, int Value); 

.386

XContext STRUC
  _esi DD ?
  _edi DD ?
  _ebx DD ?
  _ret DD ?
  _ebp DD ?
  _esp DD ?
XContext ENDS


_TEXT SEGMENT DWORD USE32 PUBLIC 'CODE'

ASSUME CS:_TEXT

PUBLIC XSaveContext
PUBLIC _XSaveContext@4
PUBLIC XRestoreContext
PUBLIC _XRestoreContext@8

XSaveContext proc near
_XSaveContext@4 label near
   pop ecx                 ; ret address
   pop edx                 ; parameter C
   mov [edx+_esi], esi     ; save all required registers
   mov [edx+_edi], edi
   mov [edx+_ebx], ebx
   mov [edx+_ret], ecx
   mov [edx+_ebp], ebp
   mov [edx+_esp], esp
   xor eax, eax            ; return code is zero
   jmp ecx                 ; and return
XSaveContext endp

XRestoreContext proc near
_XRestoreContext@8 label near
   mov edx, [esp+4]        ; parameter C
   mov eax, [esp+8]        ; parameter Value, set as return value
   mov esi, [edx+_esi]     ; restore all required registers
   mov edi, [edx+_edi]
   mov ebx, [edx+_ebx]
   mov ebp, [edx+_ebp]
   mov esp, [edx+_esp]
   jmp [edx+_ret]          ; and jump to saved context
XRestoreContext endp

_TEXT ENDS

END
