//
// SDError.h
//
// Created by Marcelo Calbucci
//
// April/2000
//

#ifndef __SDERROR_H__
#define __SDERROR_H__

#include "windows.h"

__declspec(thread) extern DWORD gdwSDLastError;

inline DWORD GetSDLastError() { return gdwSDLastError; }

// To be used by CSD, CAcl, CAce and CSid only
inline DWORD SetSDLastError(DWORD dwLastError) { return gdwSDLastError = dwLastError; }


#define SD_SUCCESS                      0x0000			
#define SD_OUT_OF_MEMORY                0x0001
#define SD_INTERNAL_ERROR               0x0002

#define SD_INVALID_SD                   0x0010
#define SD_INVALID_SID		        0x0011
#define SD_INVALID_ACL                  0x0012
#define SD_INVALID_ACE                  0x0013
#define SD_INVALID_ACE_TYPE             0x0014

#define SD_INVALID_FILE                 0x0020
#define SD_INVALID_HANDLE               0x0021
#define SD_NO_SECURITY_INFORMATION_SET  0x0022


//////////////////////////////////////////////////////////////////////
// This error codes mean a Win32 API call failed
// You can call GetLastError() from Win32 to find what error was it
// You can use the macro SD_ISW32ERROR to identify this class of errors
//////////////////////////////////////////////////////////////////////
#define WIN32_BIT                   (0x10000)
#define SD_ISW32ERROR(X)            (X&WIN32_BIT?TRUE:FALSE)

#define SD_INITIALIZE_SD_FAIL_W32   (WIN32_BIT | 0x0001)
#define SD_INITIALIZE_ACL_W32       (WIN32_BIT | 0x0002)
#define SD_MAKE_SELF_SD_W32         (WIN32_BIT | 0x0003)
#define SD_COPYSID_W32              (WIN32_BIT | 0x0004)
#define SD_CONVERT_STRING_SD_W32    (WIN32_BIT | 0x0005)

#define SD_GET_OWNER_WIN32          (WIN32_BIT | 0x0010)
#define SD_GET_GROUP_WIN32          (WIN32_BIT | 0x0011)
#define SD_GET_DACL_WIN32           (WIN32_BIT | 0x0012)
#define SD_GET_SACL_WIN32           (WIN32_BIT | 0x0013)
#define SD_GETACE_W32               (WIN32_BIT | 0x0014)
#define SD_GET_CONTROL_W32          (WIN32_BIT | 0x0015)

#define SD_SET_OWNER_W32            (WIN32_BIT | 0x0020)
#define SD_SET_GROUP_W32            (WIN32_BIT | 0x0021)
#define SD_SET_DACL_W32             (WIN32_BIT | 0x0022)
#define SD_SET_SACL_W32             (WIN32_BIT | 0x0023)
#define SD_SET_CONTROL_W32          (WIN32_BIT | 0x0024)

#define SD_ACE_ADD_FAILURE_W32      (WIN32_BIT | 0x0030)
#define SD_GET_FILE_SD_W32          (WIN32_BIT | 0x0031)
#define SD_GET_KERNEL_SD_W32        (WIN32_BIT | 0x0032)
#define SD_GET_USER_SD_W32          (WIN32_BIT | 0x0033)
#define SD_GET_SERVICE_SD_W32       (WIN32_BIT | 0x0034)
#define SD_GET_REGKEY_SD_W32        (WIN32_BIT | 0x0035)

#define SD_LOOKUP_ACCOUNT_SID_W32           (WIN32_BIT | 0x0040)
#define SD_LOOKUP_ACCOUNT_NAME_W32          (WIN32_BIT | 0x0041)
#define SD_CONVERT_SID_TO_STRING_SID_W32    (WIN32_BIT | 0x0042)
#define SD_OPEN_PROCESS_TOKEN_W32           (WIN32_BIT | 0x0043)
#define SD_OPEN_THREAD_TOKEN_W32            (WIN32_BIT | 0x0044)
#define SD_GET_TOKEN_INFORMATION_W32        (WIN32_BIT | 0x0045)
#define SD_INITIALIZE_SID_W32               (WIN32_BIT | 0x0046)

#define SD_SET_FILE_SECURITY_W32            (WIN32_BIT | 0x0050)
#define SD_SET_KERNEL_OBJECT_SECURITY_W32   (WIN32_BIT | 0x0051)
#define SD_SET_USER_OBJECT_SECURITY_W32     (WIN32_BIT | 0x0052)
#define SD_SET_SERVICE_OBJECT_SECURITY_W32  (WIN32_BIT | 0x0053)
#define SD_REG_SET_KEY_SECURITY_W32         (WIN32_BIT | 0x0054)


#endif